/*

Copyright (c) 2014-2021 Texas Instruments Incorporated

All rights reserved not granted herein.

Limited License.  

Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive license under copyrights and patents it now or hereafter owns or controls to make, have made, use, import, offer to sell and sell ("Utilize") this software subject to the terms herein.  With respect to the foregoing patent license, such license is granted  solely to the extent that any such patent is necessary to Utilize the software alone.  The patent license shall not apply to any combinations which include this software, other than combinations with devices manufactured by or for TI (“TI Devices”).  No hardware patent is licensed hereunder.

Redistributions must preserve existing copyright notices and reproduce this license (including the above copyright notice and the disclaimer and (if applicable) source code license limitations below) in the documentation and/or other materials provided with the distribution

Redistribution and use in binary form, without modification, are permitted provided that the following conditions are met:

*	No reverse engineering, decompilation, or disassembly of this software is permitted with respect to any software provided in binary form.

*	any redistribution and use are licensed by TI for use only with TI Devices.

*	Nothing shall obligate TI to provide you with source code for the software licensed and provided to you in object code.

If software source code is provided to you, modification and redistribution of the source code are permitted provided that the following conditions are met:

*	any redistribution and use of the source code, including any resulting derivative works, are licensed by TI for use only with TI Devices.

*	any redistribution and use of any object code compiled from the source code and any resulting derivative works, are licensed by TI for use only with TI Devices.

Neither the name of Texas Instruments Incorporated nor the names of its suppliers may be used to endorse or promote products derived from this software without specific prior written permission.

DISCLAIMER.

THIS SOFTWARE IS PROVIDED BY TI AND TI’S LICENSORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TI’S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef TOUCHPATH_GESTURE_ENGINE_H
#define TOUCHPATH_GESTURE_ENGINE_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "system.h"

//-----------------------------------------------
// Gesture Codes
//-----------------------------------------------
#define PAN_UP 0x01
#define PAN_RIGHT 0x02
#define PAN_DOWN 0x03
#define PAN_LEFT 0x04

#define NO_GESTURE 0x00

#define ST_UP 0x01
#define ST_RIGHT 0x02
#define ST_DOWN 0x03
#define ST_LEFT 0x04

#define ST_FLICK_SLOW_UP 0x05
#define ST_FLICK_SLOW_RIGHT 0x06
#define ST_FLICK_SLOW_DOWN 0x07
#define ST_FLICK_SLOW_LEFT 0x08

#define ST_FLICK_FAST_UP 0x09
#define ST_FLICK_FAST_RIGHT 0x0A
#define ST_FLICK_FAST_DOWN 0x0B
#define ST_FLICK_FAST_LEFT 0x0C

#define ST_CLICK 0x0D
#define ST_DOUBLECLICK 0x0E

#define MT_UP 0x10
#define MT_RIGHT 0x11
#define MT_DOWN 0x12
#define MT_LEFT 0x13

#define ZOOM_IN 0x14
#define ZOOM_OUT 0x15
#define ROTATE_CLOCKWISE 0x16
#define ROTATE_COUNTERCLOCKWISE 0x17

#define ROTATE_ON 1

	BYTE TouchpathGestureEngine_GetGestureID(BYTE bTouchFingerCount);

	void TouchpathGestureEngine_Initialize(void);
	void TouchpathGestureEngine_SetDeltaXY(WORD wDeltaX, WORD wDeltaY, WORD w_X1, WORD w_Y1, WORD w_X2, WORD w_Y2);

	void TouchpathGestureEngine_SetXY(WORD posX0, WORD posY0);

#ifdef __cplusplus
};
#endif

#endif
